SoToVRML2Action Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
SoToVRML2Action Class Reference
Action Classes

The SoToVRML2Action class builds a new scene graph, using only VRML97/VRML2 nodes.This action is used for converting a scene graph of VRML1/Coin nodes to a new scene graph using only VRML97/VRML2 nodes. More...

`#include <Inventor/actions/SoToVRML2Action.h>`

Inheritance diagram for SoToVRML2Action:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoToVRML2Action (void)
virtual | ~SoToVRML2Action (void)
virtual void | apply (SoNode *node)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
class SoVRMLGroup * | getVRML2SceneGraph (void) const
void | reuseAppearanceNodes (SbBool appearance)
SbBool | doReuseAppearanceNodes (void) const
void | reusePropertyNodes (SbBool property)
SbBool | doReusePropertyNodes (void) const
void | reuseGeometryNodes (SbBool geometry)
SbBool | doReuseGeometryNodes (void) const
Public Member Functions inherited from SoToVRMLAction
| SoToVRMLAction (void)
virtual | ~SoToVRMLAction (void)
SoNode * | getVRMLSceneGraph (void) const
void | expandSoFile (SbBool flag)
SbBool | areSoFileExpanded (void) const
void | setUrlName (const SbString name)
SbString | getUrlName (void) const
void | writeTexCoords (SbBool flag)
SbBool | areTexCoordWritten (void) const
void | expandTexture2Node (SbBool flag)
SbBool | areTexture2NodeExpanded (void) const
void | keepUnknownNodes (SbBool flag)
SbBool | areUnknownNodeKept (void) const
void | convertInlineNodes (SbBool flag)
SbBool | doConvertInlineNodes (void) const
void | conditionalConversion (SbBool flag)
SbBool | doConditionalConversion (void) const
void | setVerbosity (SbBool flag)
SbBool | isVerbose (void) const
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoToVRMLAction
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions
virtual const SoEnabledElementsList & | getEnabledElements (void) const
virtual void | beginTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoToVRMLAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Additional Inherited Members
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0, PATH = 1, PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0, IN_PATH = 1, BELOW_PATH = 2, OFF_PATH = 3 }
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Detailed Description

The SoToVRML2Action class builds a new scene graph, using only VRML97/VRML2 nodes.

This action is used for converting a scene graph of VRML1/Coin nodes to a new scene graph using only VRML97/VRML2 nodes.

Due to the basic differences between VRML1/Coin and VRML2 (the latter does not really have a traversal state) the new scene graph will typically be somewhat larger. To minimize this effect the action tries to re-use nodes when possible.

VRML1 nodes will be converted to its direct equivalent VRML2 node, while Coin nodes with no VRML2 equivalent are converted to IndexedFaceSet. If the DrawStyle is POINTS, all geometry will be built using PointSet; if it is LINES IndexedLineSet is used.

Here's a basic usage example of this action, in the form of a complete, stand-alone program:

#include <Inventor/SoDB.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoOutput.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoToVRML2Action.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/VRMLnodes/SoVRMLGroup.h>
int
main(int argc, char *argv[])
{
SoDB::init();
SoInteraction::init();
SoInput in;
in.openFile(argv[1]);
printf("Reading...\n");
SoSeparator *root = SoDB::readAll(&in);
if (root) {
root->ref();
SbString hdr = in.getHeader();
in.closeFile();
printf("Converting...\n");
SoToVRML2Action tovrml2;
tovrml2.apply(root);
SoVRMLGroup *newroot = tovrml2.getVRML2SceneGraph();
newroot->ref();
root->unref();
printf("Writing...\n");
SoOutput out;
out.openFile("out.wrl");
out.setHeaderString("#VRML V2.0 utf8");
SoWriteAction wra(&out);
wra.apply(newroot);
out.closeFile();
newroot->unref();
}
return 0;
}

Note: if VRML97 support is not present in the Coin library, this action does nothing and getVRML2SceneGraph always returns `NULL`.

See also
  SoToVRMLAction

Since
  Coin 2.0
  TGS Inventor 2.5

## Constructor & Destructor Documentation

SoToVRML2Action::SoToVRML2Action | ( | void |  | ) |

Constructor.

SoToVRML2Action::~SoToVRML2Action | ( | void |  | ) |
| virtual

The destructor.

## Member Function Documentation

SoType SoToVRML2Action::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an action derived from a class inheriting SoAction. This is used for run-time type checking and "downward" casting.

Usage example:

void bar(SoAction * action)
{
if (action->getTypeId() == SoGLRenderAction::getClassTypeId()) {
// safe downward cast, know the type
SoGLRenderAction * glrender = (SoGLRenderAction *)action;
}
return; // ignore if not renderaction
}

For application programmers wanting to extend the library with new actions: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through Inventor/nodes/SoSubAction.h: SO_ACTION_SOURCE, SO_ACTION_INIT_CLASS and SO_ACTION_CONSTRUCTOR.

For more information on writing Coin extensions, see the SoAction class documentation.

Returns the actual type id of an object derived from a class inheriting SoAction. Needs to be overridden in all subclasses.

Reimplemented from SoToVRMLAction.

void SoToVRML2Action::addMethod | ( | const SoType | type,
|  | SoActionMethod | method
| ) |  |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoToVRML2Action::enableElement | ( | const SoType | type,
|  | const int | stackindex
| ) |  |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

const SoEnabledElementsList & SoToVRML2Action::getEnabledElements | ( | void |  | ) | const
| protectedvirtual

Returns a list of the elements used by action instances of this class upon traversal operations.

Reimplemented from SoToVRMLAction.

void SoToVRML2Action::apply | ( | SoNode * | root | ) |
| virtual

Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoToVRMLAction.

void SoToVRML2Action::apply | ( | SoPath * | path | ) |
| virtual

Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoToVRMLAction.

void SoToVRML2Action::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = `FALSE`
| ) |  |
| virtual

Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
  SoAction::apply(SoPath * path)

Reimplemented from SoToVRMLAction.

SoVRMLGroup * SoToVRML2Action::getVRML2SceneGraph | ( | void |  | ) | const

Return a pointer to the root node of the generated scenegraph of only VRML2 / VRML97 nodes.

Will return `NULL` if VRML97 support was not compiled into the library.

void SoToVRML2Action::reuseAppearanceNodes | ( | SbBool | appearance | ) |

Set the flag deciding if appearance nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Appearance nodes is not implemented yet.

SbBool SoToVRML2Action::doReuseAppearanceNodes | ( | void |  | ) | const

Get the flag deciding if appearance nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Appearance nodes is not implemented yet, so this method will always return FALSE.

void SoToVRML2Action::reusePropertyNodes | ( | SbBool | property | ) |

Set the flag deciding if property nodes should be reused if possible. The default is FALSE.

SbBool SoToVRML2Action::doReusePropertyNodes | ( | void |  | ) | const

Get the flag deciding if property nodes should be reused if possible. The default is FALSE.

void SoToVRML2Action::reuseGeometryNodes | ( | SbBool | geometry | ) |

Set the flag deciding if geometry nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Geometry nodes is not implemented yet.

SbBool SoToVRML2Action::doReuseGeometryNodes | ( | void |  | ) | const

Get the flag deciding if geometry nodes should be reused if possible. The default is FALSE.

Please note that support for reusing Geometry nodes is not implemented yet, so this function will always return FALSE.

void SoToVRML2Action::beginTraversal | ( | SoNode * | node | ) |
| protectedvirtual

This virtual method is called from SoAction::apply(), and is the entry point for the actual scenegraph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scenegraph traversal.

Reimplemented from SoToVRMLAction.

The documentation for this class was generated from the following files:

- SoToVRML2Action.h
- SoToVRML2Action.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.